/* tracking macros to use tracker routines */

#ifdef TRACKER

#define AllocMem(x,y) TrackingAllocMem(x,y,__FILE__,__LINE__)
#define FreeMem(x,y) TrackingFreeMem(x,y,__FILE__,__LINE__)

#define AllocSignal(x) TrackingAllocSignal(x,__FILE__,__LINE__)
#define FreeSignal(x) TrackingFreeSignal(x,__FILE__,__LINE__)

#define Lock(x,y) TrackingLock(x,__FILE__,__LINE__)
#define UnLock(x,y) TrackingUnLock(x,__FILE__,__LINE__)
#define DupLock(x) TrackingDupLock(x,__FILE__,__LINE__)

void *TrackingAllocMem();
void TrackingFreeMem();

long TrackingAllocSignal();
void TrackingFreeSignal();

void *TrackingAllocRaster();
void TrackingFreeRaster();

struct FileLock *TrackingLock();
void TrackingUnLock();

#endif
